# Race detector simplified

NA: non-atomic / AT : atomic

* An NA write must have seen all other operations
* An NA read must have seen all writes (NA & AT)
* An AT write must have seen all NA operations (read & writes)
* An AT read must have seen all NA writes

| Must have seen   | NA write | NA read  | AT write | AT read |
| -----------------| --------:| --------:| --------:| -------:|
| NA write         | +        | +        | +        | +       |
| NA read          | +        |          | +        |         |
| AT write         | +        | +        |          |         |
| AT read          | +        |          |          |         |
